<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>PySpottedUnipd: /home/stefano/Coding/Python/projects/spotted-unipd/pyspottedunipd/ngrams/models.py Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">PySpottedUnipd
   &#160;<span id="projectnumber">0.0.2</span>
   </div>
   <div id="projectbrief">Figure out how you can find your sweet half or how to get attention and get liked in one of the most popular @Unipd facebook pages.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('ngrams_2models_8py_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">models.py</div>  </div>
</div><!--header-->
<div class="contents">
<a href="ngrams_2models_8py.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno"><a class="line" href="namespacepyspottedunipd_1_1ngrams_1_1models.html">    1</a></span>&#160;<span class="comment"># !/usr/bin/python3</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"># coding: utf-8</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;</div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"># Copyright 2017 Stefano Fogarollo</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">#</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"># Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"># you may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"># You may obtain a copy of the License at</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">#</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"># http://www.apache.org/licenses/LICENSE-2.0</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">#</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"># Unless required by applicable law or agreed to in writing, software</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"># distributed under the License is distributed on an &quot;AS IS&quot; BASIS,</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"># WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># See the License for the specific language governing permissions and</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"># limitations under the License.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">import</span> random</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">import</span> re</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">from</span> collections <span class="keyword">import</span> Counter</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">from</span> random <span class="keyword">import</span> choice</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html">   25</a></span>&#160;<span class="keyword">class </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html">Cup</a>(object):</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="stringliteral">&quot;&quot;&quot; A class defining a cup that will hold the words that we will pull out &quot;&quot;&quot;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a16523993610a514d02700a8cb5f20c3f">   28</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a16523993610a514d02700a8cb5f20c3f">__init__</a>(self):</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        object.__init__(self)</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a34c3084faed8105b894a960e39b2afa8">   31</a></span>&#160;        self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a34c3084faed8105b894a960e39b2afa8">next_word</a> = Counter()  <span class="comment"># will keep track of how many times a word appears in a cup</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a2d8043239f6a2be5041b59c13b010adb">   33</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a2d8043239f6a2be5041b59c13b010adb">add_next_word</a>(self, word):</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="stringliteral">&quot;&quot;&quot;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="stringliteral">        :param word: str</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="stringliteral">            Next word to add</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="stringliteral">        :return: void</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="stringliteral">            Used to add words to the cup and keep track of how many times we see it</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="stringliteral">        &quot;&quot;&quot;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a34c3084faed8105b894a960e39b2afa8">next_word</a>[word] += 1</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html">   44</a></span>&#160;<span class="keyword">class </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html">NGram</a>(object):</div><div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a2a5c55a3303d7da0f410ebe18b4f3d5d">   45</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a2a5c55a3303d7da0f410ebe18b4f3d5d">__init__</a>(self):</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        object.__init__(self)</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    @staticmethod</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#af6474ffdf656cebb90cbfcaa925d40cb">   49</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#af6474ffdf656cebb90cbfcaa925d40cb">make_cups</a>(order, string):</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="stringliteral">&quot;&quot;&quot;</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="stringliteral">        :param order: int</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="stringliteral">            Order of n-grams to generate</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="stringliteral">        :param string: str</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="stringliteral">            Input text</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="stringliteral">        :return: cups</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="stringliteral">            Get a string of input text and make all the unique cups with the different words in it</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="stringliteral">        &quot;&quot;&quot;</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        cups = dict()</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        words = re.findall(<span class="stringliteral">r&quot;([\w]+)&quot;</span>, string)</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(len(words) - order):</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            token = []</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            next_word = words[i + order]</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            <span class="keywordflow">for</span> j <span class="keywordflow">in</span> range(order):</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;                token.append(words[i + j])</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            <span class="comment"># create a cup if we&quot;ve never seen this token before</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;            <span class="keywordflow">if</span> tuple(token) <span class="keywordflow">not</span> <span class="keywordflow">in</span> cups:</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;                cups[tuple(token)] = <a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html">Cup</a>()</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;                cups[tuple(token)].add_next_word(next_word)</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;            <span class="keywordflow">else</span>:</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;                cups[tuple(token)].add_next_word(next_word)</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">return</span> cups</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    @staticmethod</div><div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a654e3fc83a4a2cced0a9207558c651c3">   75</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a654e3fc83a4a2cced0a9207558c651c3">print_cups</a>(cups):</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        <span class="stringliteral">&quot;&quot;&quot;</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="stringliteral">        :param cups: Cup</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="stringliteral">            Cup to use</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="stringliteral">        :return: void</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="stringliteral">            Use this to see what cups there are and the words inside of it</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="stringliteral">        &quot;&quot;&quot;</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keywordflow">for</span> token <span class="keywordflow">in</span> list(cups.keys()):</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            print(<span class="stringliteral">&quot;key %s : nextword %s&quot;</span> % (token, cups[token].next_word))</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    @staticmethod</div><div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a0715ce38bf5c01f6850aeddc483515df">   87</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a0715ce38bf5c01f6850aeddc483515df">topword</a>(n, cup):</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="stringliteral">&quot;&quot;&quot;</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="stringliteral">        :param n: int</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="stringliteral">            Number of top words to take from cup</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="stringliteral">        :param cup: Cup</span></div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="stringliteral">            Cup to use</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="stringliteral">        :return: str</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;<span class="stringliteral">            A function that picks the top words in a cup</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;<span class="stringliteral">        &quot;&quot;&quot;</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        temp = list(reversed(sorted(cup.next_word, key=cup.next_word.get)))  <span class="comment"># reverse sort based on values</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keywordflow">if</span> len(temp[:n]) &gt; 0:</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            <span class="keywordflow">return</span> choice(temp[:n])  <span class="comment"># random element from the temp list</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        <span class="keywordflow">else</span>:</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            <span class="keywordflow">return</span> <span class="stringliteral">&quot;&quot;</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div><div class="line"><a name="l00103"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a6fb8e14cc45dc03c7cd250a7f6804c70">  103</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a6fb8e14cc45dc03c7cd250a7f6804c70">generate_from_file</a>(self, order, filename, number_of_words):</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="stringliteral">&quot;&quot;&quot;</span></div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="stringliteral">        :param order: int</span></div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="stringliteral">            Order of n-gram</span></div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="stringliteral">        :param filename: str</span></div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="stringliteral">            Path to filename</span></div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="stringliteral">        :param number_of_words: int</span></div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="stringliteral">            Number of words to generate</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="stringliteral">        :return: str</span></div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;<span class="stringliteral">            Generate words based on a text file</span></div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="stringliteral">        &quot;&quot;&quot;</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;        with open(filename, <span class="stringliteral">&quot;r&quot;) as f:  # put file in one big string</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="stringliteral">            string = f.read()</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="stringliteral"></span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="stringliteral">        </span><span class="keywordflow">return</span> self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#adde2b71326b9837fffbf642057167fab">generate_from_string</a>(order, string, number_of_words)</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00120"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#adde2b71326b9837fffbf642057167fab">  120</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#adde2b71326b9837fffbf642057167fab">generate_from_string</a>(self, order, string, number_of_words):</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        <span class="stringliteral">&quot;&quot;&quot;</span></div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;<span class="stringliteral">        :param order: int</span></div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="stringliteral">            Order of n-gram</span></div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="stringliteral">        :param string: str</span></div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="stringliteral">            Input string</span></div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="stringliteral">        :param number_of_words: int</span></div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;<span class="stringliteral">            Number of words to generate</span></div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="stringliteral">        :return: str</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;<span class="stringliteral">            Generate words based on a text file</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="stringliteral">        &quot;&quot;&quot;</span></div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        string = re.sub(<span class="stringliteral">&quot;[,.?&#39;-\&#39;!:;]&quot;</span>, <span class="stringliteral">&quot;&quot;</span>, string)</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        cups = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#af6474ffdf656cebb90cbfcaa925d40cb">make_cups</a>(order, string)</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        first_token = choice(list(cups.keys()))  <span class="comment"># random first token</span></div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        this_token = first_token</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        generated_words = []</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        generated_words += list(this_token)</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(1, number_of_words):</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;            <span class="comment"># if the name of the token exists</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;            <span class="keywordflow">if</span> this_token <span class="keywordflow">in</span> cups:</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;                next_word = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a0715ce38bf5c01f6850aeddc483515df">topword</a>(2, cups[this_token])</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;            <span class="keywordflow">else</span>:</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;                this_token = choice(list(cups.keys()))  <span class="comment"># random token</span></div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                next_word = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a0715ce38bf5c01f6850aeddc483515df">topword</a>(2, cups[this_token])</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;            temp = list(this_token)</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;            temp.pop(0)  <span class="comment"># remove first word in token</span></div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;            temp.append(next_word)  <span class="comment"># add new word to the end of the token</span></div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            next_token = tuple(temp)</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;            this_token = next_token</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            generated_words += [next_word]</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        print(<span class="stringliteral">&quot; &quot;</span>.join(generated_words))</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html">  160</a></span>&#160;<span class="keyword">class </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html">Markov</a>(object):</div><div class="line"><a name="l00161"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a0226e0f7e9d56f17cfe9805194849e0f">  161</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a0226e0f7e9d56f17cfe9805194849e0f">__init__</a>(self, open_file):</div><div class="line"><a name="l00162"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad77e8269974806f9945d4a14587b0dfc">  162</a></span>&#160;        self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad77e8269974806f9945d4a14587b0dfc">cache</a> = {}</div><div class="line"><a name="l00163"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a5024f57db6188d5d51664ca7acdc6986">  163</a></span>&#160;        self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a5024f57db6188d5d51664ca7acdc6986">open_file</a> = open_file</div><div class="line"><a name="l00164"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">  164</a></span>&#160;        self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">words</a> = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a4efc3f55efaf7424106f13971addd0f2">file_to_words</a>()</div><div class="line"><a name="l00165"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad113500f81d87ba3517e5c2fe60fb7cc">  165</a></span>&#160;        self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad113500f81d87ba3517e5c2fe60fb7cc">word_size</a> = len(self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">words</a>)</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#aecacdd3b80908aec0ac36d6760c23d22">database</a>()</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div><div class="line"><a name="l00168"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a4efc3f55efaf7424106f13971addd0f2">  168</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a4efc3f55efaf7424106f13971addd0f2">file_to_words</a>(self):</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        data = open(self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a5024f57db6188d5d51664ca7acdc6986">open_file</a>, <span class="stringliteral">&quot;r&quot;).read()</span></div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;<span class="stringliteral">        words = data.split()</span></div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="stringliteral">        </span><span class="keywordflow">return</span> words</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div><div class="line"><a name="l00173"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a3c3efbeb47f0f50687826d1d4da1514d">  173</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a3c3efbeb47f0f50687826d1d4da1514d">triples</a>(self):</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="stringliteral">&quot;&quot;&quot; Generates triples from the given data string. So if our string were</span></div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;<span class="stringliteral">                &quot;What a lovely day&quot;, we&quot;d generate (What, a, lovely) and then</span></div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="stringliteral">                (a, lovely, day).</span></div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="stringliteral">        &quot;&quot;&quot;</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="keywordflow">if</span> len(self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">words</a>) &lt; 3:</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;            <span class="keywordflow">return</span></div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(len(self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">words</a>) - 2):</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;            <span class="keywordflow">yield</span> (self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">words</a>[i], self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">words</a>[i + 1], self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">words</a>[i + 2])</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#aecacdd3b80908aec0ac36d6760c23d22">  185</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#aecacdd3b80908aec0ac36d6760c23d22">database</a>(self):</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        <span class="keywordflow">for</span> w1, w2, w3 <span class="keywordflow">in</span> self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a3c3efbeb47f0f50687826d1d4da1514d">triples</a>():</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;            key = (w1, w2)</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;            <span class="keywordflow">if</span> key <span class="keywordflow">in</span> self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad77e8269974806f9945d4a14587b0dfc">cache</a>:</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;                self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad77e8269974806f9945d4a14587b0dfc">cache</a>[key].append(w3)</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            <span class="keywordflow">else</span>:</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad77e8269974806f9945d4a14587b0dfc">cache</a>[key] = [w3]</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00193"></a><span class="lineno"><a class="line" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a19bccbd777575d1c3e036d4609be0355">  193</a></span>&#160;    <span class="keyword">def </span><a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a19bccbd777575d1c3e036d4609be0355">generate_markov_text</a>(self, size=25):</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        seed = random.randint(0, self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad113500f81d87ba3517e5c2fe60fb7cc">word_size</a> - 3)</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        seed_word, next_word = self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">words</a>[seed], self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">words</a>[seed + 1]</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        w1, w2 = seed_word, next_word</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        gen_words = []</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keywordflow">for</span> i <span class="keywordflow">in</span> range(size):</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;            gen_words.append(w1)</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            w1, w2 = w2, random.choice(self.<a class="code" href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad77e8269974806f9945d4a14587b0dfc">cache</a>[(w1, w2)])</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        gen_words.append(w2)</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keywordflow">return</span> <span class="stringliteral">&quot; &quot;</span>.join(gen_words)</div><div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram_html_a0715ce38bf5c01f6850aeddc483515df"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a0715ce38bf5c01f6850aeddc483515df">pyspottedunipd.ngrams.models.NGram.topword</a></div><div class="ttdeci">def topword(n, cup)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00087">models.py:87</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html_a5024f57db6188d5d51664ca7acdc6986"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a5024f57db6188d5d51664ca7acdc6986">pyspottedunipd.ngrams.models.Markov.open_file</a></div><div class="ttdeci">open_file</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00163">models.py:163</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html_a0226e0f7e9d56f17cfe9805194849e0f"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a0226e0f7e9d56f17cfe9805194849e0f">pyspottedunipd.ngrams.models.Markov.__init__</a></div><div class="ttdeci">def __init__(self, open_file)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00161">models.py:161</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram_html_af6474ffdf656cebb90cbfcaa925d40cb"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#af6474ffdf656cebb90cbfcaa925d40cb">pyspottedunipd.ngrams.models.NGram.make_cups</a></div><div class="ttdeci">def make_cups(order, string)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00049">models.py:49</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram_html_a6fb8e14cc45dc03c7cd250a7f6804c70"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a6fb8e14cc45dc03c7cd250a7f6804c70">pyspottedunipd.ngrams.models.NGram.generate_from_file</a></div><div class="ttdeci">def generate_from_file(self, order, filename, number_of_words)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00103">models.py:103</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup_html_a2d8043239f6a2be5041b59c13b010adb"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a2d8043239f6a2be5041b59c13b010adb">pyspottedunipd.ngrams.models.Cup.add_next_word</a></div><div class="ttdeci">def add_next_word(self, word)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00033">models.py:33</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html_aecacdd3b80908aec0ac36d6760c23d22"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#aecacdd3b80908aec0ac36d6760c23d22">pyspottedunipd.ngrams.models.Markov.database</a></div><div class="ttdeci">def database(self)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00185">models.py:185</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram_html_a654e3fc83a4a2cced0a9207558c651c3"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a654e3fc83a4a2cced0a9207558c651c3">pyspottedunipd.ngrams.models.NGram.print_cups</a></div><div class="ttdeci">def print_cups(cups)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00075">models.py:75</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html_a566f006d449d2eb99cd4c16ad75de402"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a566f006d449d2eb99cd4c16ad75de402">pyspottedunipd.ngrams.models.Markov.words</a></div><div class="ttdeci">words</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00164">models.py:164</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram_html_a2a5c55a3303d7da0f410ebe18b4f3d5d"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#a2a5c55a3303d7da0f410ebe18b4f3d5d">pyspottedunipd.ngrams.models.NGram.__init__</a></div><div class="ttdeci">def __init__(self)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00045">models.py:45</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup_html_a16523993610a514d02700a8cb5f20c3f"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a16523993610a514d02700a8cb5f20c3f">pyspottedunipd.ngrams.models.Cup.__init__</a></div><div class="ttdeci">def __init__(self)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00028">models.py:28</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram_html_adde2b71326b9837fffbf642057167fab"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html#adde2b71326b9837fffbf642057167fab">pyspottedunipd.ngrams.models.NGram.generate_from_string</a></div><div class="ttdeci">def generate_from_string(self, order, string, number_of_words)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00120">models.py:120</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html_ad113500f81d87ba3517e5c2fe60fb7cc"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad113500f81d87ba3517e5c2fe60fb7cc">pyspottedunipd.ngrams.models.Markov.word_size</a></div><div class="ttdeci">word_size</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00165">models.py:165</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html_ad77e8269974806f9945d4a14587b0dfc"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#ad77e8269974806f9945d4a14587b0dfc">pyspottedunipd.ngrams.models.Markov.cache</a></div><div class="ttdeci">cache</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00162">models.py:162</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram_html"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_n_gram.html">pyspottedunipd.ngrams.models.NGram</a></div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00044">models.py:44</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup_html"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html">pyspottedunipd.ngrams.models.Cup</a></div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00025">models.py:25</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html">pyspottedunipd.ngrams.models.Markov</a></div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00160">models.py:160</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup_html_a34c3084faed8105b894a960e39b2afa8"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_cup.html#a34c3084faed8105b894a960e39b2afa8">pyspottedunipd.ngrams.models.Cup.next_word</a></div><div class="ttdeci">next_word</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00031">models.py:31</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html_a4efc3f55efaf7424106f13971addd0f2"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a4efc3f55efaf7424106f13971addd0f2">pyspottedunipd.ngrams.models.Markov.file_to_words</a></div><div class="ttdeci">def file_to_words(self)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00168">models.py:168</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html_a3c3efbeb47f0f50687826d1d4da1514d"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a3c3efbeb47f0f50687826d1d4da1514d">pyspottedunipd.ngrams.models.Markov.triples</a></div><div class="ttdeci">def triples(self)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00173">models.py:173</a></div></div>
<div class="ttc" id="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov_html_a19bccbd777575d1c3e036d4609be0355"><div class="ttname"><a href="classpyspottedunipd_1_1ngrams_1_1models_1_1_markov.html#a19bccbd777575d1c3e036d4609be0355">pyspottedunipd.ngrams.models.Markov.generate_markov_text</a></div><div class="ttdeci">def generate_markov_text(self, size=25)</div><div class="ttdef"><b>Definition:</b> <a href="ngrams_2models_8py_source.html#l00193">models.py:193</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_cadfa51a49c9afcc310fa35ae151bb00.html">pyspottedunipd</a></li><li class="navelem"><a class="el" href="dir_99175f8b6c783221f605e721a02ede92.html">ngrams</a></li><li class="navelem"><a class="el" href="ngrams_2models_8py.html">models.py</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
